{-# LANGUAGE NamedFieldPuns #-}
{-# LANGUAGE RecordWildCards #-}
{-# LANGUAGE OverloadedStrings #-}

module DataTypes where

{-- a::Text   -- OverloadedStrings
a="aaa"
b::String
b="aaa"
--}
type Point2D = (Double, Double)

dots :: Point2D -> Point2D -> Double
dots (x1, y1) (x2, y2) = x1 * x2 + y1 * y2

newtype Point1D =
  Pt1D Double

{-- sum --}
data Sex
  = Male
  | Female
  deriving (Show, Enum)

show' :: Sex -> String
-- show Male -> "M"
-- show Female -> "F"
show' Male = "Male"
show' _ = "Female"

-- case-of
show'' s =
  case s of
    Male -> "Male"
    _ -> "Female"

{-- prod --}
type Name = String

type Age = Int

--data Person = Person Name Age Sex deriving (Show)
age' :: Person -> Age
age' (Person _ age _) = age

age'' (Person {age}) = age -- NamedFieldPuns

age''' (Person {..}) = age -- RecordWildCards

data Person = Person
  { name :: Name
  , age :: Age
  , sex :: Sex
  } deriving (Show)

data Point =
  Point Double
        Double
  deriving (Show)

data Radius =
  Double
  deriving (Show)

--data Shape = Circle Point Radius | Rectangle Point Point deriving (Show)
data Shape
  = Circle { center :: Point
           , radius :: Radius }
  | Rectangle { lUCorner :: Point
              , rDCorner :: Point }
  deriving (Show)

data T
  = D1 { f :: Int }
  | D2 { f :: Int }
  deriving (Show)

{-- polymorphic --}
data Pt3D a b c = Pt3D
  { x :: a
  , y :: b
  , z :: c
  }
-- :k Pt3D
-- Pt3D :: * -> * -> * -> *

{-- recursive --}
data List a
  = Nil
  | Cons a
         (List a) --deriving (Show)

-- data [] a = [] | a : ([]a)
instance (Show a) => Show (List a) where
  show Nil = "[]"
  show (Cons x xs) = show x ++ ":" ++ show xs

{-- infinite --}
ones = 1 : ones

fibs = 0 : 1 : zipWith (+) fibs (tail fibs)

{-- List comprehensions --}
--[(x,y,z) | x<-[1..10], y<-[1..10], z<-[1..10], x*x+y*y == z*z]
f' :: Int -> Sex
f' n = undefined

const' :: a -> b -> a
const' x y = x

-- `seq`
-- $!
-- space leak

-- a = NumPairLazy (1+1) undefined
data NumPairLazy =
  NumPairLazy Int
              Int
  deriving (Show)

-- a = NumPairStrong (1+1) undefined
data NumPairStrong =
  NumPairStrong !Int
                !Int
  deriving (Show)
